<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/Texinfo.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/Texinfo.py</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/Texinfo.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-string">&quot;&quot;&quot;a TexInfo formatter &quot;&quot;&quot;</span></span>
<a id="line10"></a><span class="lineno"> 10</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> Synopsis.DocString <span class="py-keyword">import</span> DocString</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">import</span> sys, os, re</span>
<a id="line15"></a><span class="lineno"> 15</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">_tags = re.compile(<span class="py-string">r'@(?!(table|item|samp|end))'</span>)</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo.html#escape">escape</a>(text):</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">   <span class="py-keyword">return</span> _tags.sub(<span class="py-string">'@@'</span>, text).replace(<span class="py-string">'{'</span>, <span class="py-string">'@{'</span>).replace(<span class="py-string">'}'</span>, <span class="py-string">'@}'</span>)</span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/MenuMaker.html">MenuMaker</a>(ASG.Visitor):</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">   <span class="py-string">&quot;&quot;&quot;generate a texinfo menu for the declarations of a given scope&quot;&quot;&quot;</span></span>
<a id="line25"></a><span class="lineno"> 25</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/MenuMaker.html#__init__">__init__</a>(self, scope, os):</span>
<a id="line27"></a><span class="lineno"> 27</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">      self.scope = scope</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">      self.os = os</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/MenuMaker.html#write">write</a>(self, text): self.os.write(text)</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/MenuMaker.html#start">start</a>(self): self.write(<span class="py-string">'@menu\n'</span>)</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/MenuMaker.html#end">end</a>(self): self.write(<span class="py-string">'@end menu\n'</span>)</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/MenuMaker.html#visit_declaration">visit_declaration</a>(self, node):</span>
<a id="line35"></a><span class="lineno"> 35</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">      name = escape(str(self.scope.prune(node.name)))</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">      self.write(<span class="py-string">'* '</span> + name + <span class="py-string">'::\t'</span> + node.type + <span class="py-string">'\n'</span>)</span>
<a id="line38"></a><span class="lineno"> 38</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">   visit_group = visit_declaration</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">   visit_enum = visit_declaration</span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-keyword">class</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html">Formatter</a>(Processor, ASG.Visitor):</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">   <span class="py-string">&quot;&quot;&quot;The type visitors should generate names relative to the current scope.</span></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-string">   The generated references however are fully scoped names.&quot;&quot;&quot;</span></span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#process">process</a>(self, ir, **kwds):</span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">      self.set_parameters(kwds)</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">      <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.output: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'output'</span>)</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">      self.ir = self.merge_input(ir)</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">      self.os = open(self.output, <span class="py-string">'w+'</span>)</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">      self.scope = ()</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> self.ir.asg.declarations:</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">         d.accept(self)</span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">      <span class="py-keyword">return</span> self.ir</span>
<a id="line58"></a><span class="lineno"> 58</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#write">write</a>(self, text): self.os.write(text)</span>
<a id="line60"></a><span class="lineno"> 60</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#type_label">type_label</a>(self): <span class="py-keyword">return</span> escape(self.__type_label)</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#decl_label">decl_label</a>(self, decl): <span class="py-keyword">return</span> escape(decl[-1])</span>
<a id="line64"></a><span class="lineno"> 64</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#format_type">format_type</a>(self, type):</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">      <span class="py-string">&quot;Returns a reference string for the given type object&quot;</span></span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">      <span class="py-keyword">if</span> type <span class="py-keyword">is</span> None: <span class="py-keyword">return</span> <span class="py-string">&quot;(unknown)&quot;</span></span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">      type.accept(self)</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">      <span class="py-keyword">return</span> self.type_label()</span>
<a id="line71"></a><span class="lineno"> 71</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#format_comments">format_comments</a>(self, decl):</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">      doc = decl.annotations.get(<span class="py-string">'doc'</span>, DocString(<span class="py-string">''</span>, <span class="py-string">''</span>))</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">      <span class="py-comment"># TODO: implement markup formatters for e.g. javadoc and rst</span></span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">      self.write(escape(doc.text) + <span class="py-string">'\n'</span>)</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">   <span class="py-comment">#################### Type Visitor ###########################################</span></span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_builtin_type_id">visit_builtin_type_id</a>(self, type):</span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">      self.__type_ref = str(type.name)</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">      self.__type_label = str(type.name)</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_unknown_type_id">visit_unknown_type_id</a>(self, type):</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">      self.__type_ref = str(type.name)</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">      self.__type_label = str(self.scope.prune(type.name))</span>
<a id="line89"></a><span class="lineno"> 89</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_declared_type_id">visit_declared_type_id</a>(self, type):</span>
<a id="line91"></a><span class="lineno"> 91</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">      self.__type_label = str(self.scope.prune(type.name))</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">      self.__type_ref = str(type.name)</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_modifier_type_id">visit_modifier_type_id</a>(self, type):</span>
<a id="line96"></a><span class="lineno"> 96</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">      type.alias.accept(self)</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">      self.__type_ref = <span class="py-string">''</span>.join(type.premod) + <span class="py-string">' '</span> + self.__type_ref + <span class="py-string">' '</span> + <span class="py-string">''</span>.join(type.postmod)</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">      self.__type_label = <span class="py-string">''</span>.join(type.premod) + <span class="py-string">' '</span> + self.__type_label + <span class="py-string">' '</span> + <span class="py-string">''</span>.join(type.postmod)</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_parametrized_type_id">visit_parametrized_type_id</a>(self, type):</span>
<a id="line102"></a><span class="lineno">102</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">      <span class="py-keyword">if</span> type.template:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">         type.template.accept(self)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">         type_label = self.__type_label + <span class="py-string">'&lt;'</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line">      <span class="py-keyword">else</span>: type_label = <span class="py-string">'(unknown)&lt;'</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">      parameters_label = []</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">      <span class="py-keyword">for</span> p <span class="py-keyword">in</span> type.parameters:</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">         p.accept(self)</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">         parameters_label.append(self.__type_label)</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">      self.__type_label = type_label + <span class="py-string">', '</span>.join(parameters_label) + <span class="py-string">'&gt;'</span></span>
<a id="line112"></a><span class="lineno">112</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_function_type_id">visit_function_type_id</a>(self, type):</span>
<a id="line114"></a><span class="lineno">114</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">      <span class="py-comment"># TODO: this needs to be implemented</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">      self.__type_ref = <span class="py-string">'function_type'</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line">      self.__type_label = <span class="py-string">'function_type'</span></span>
<a id="line118"></a><span class="lineno">118</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">   <span class="py-comment">#################### ASG Visitor ############################################</span></span>
<a id="line120"></a><span class="lineno">120</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_declarator">visit_declarator</a>(self, node):</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">      self.__declarator = node.name</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">      <span class="py-keyword">for</span> i <span class="py-keyword">in</span> node.sizes:</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">         self.__declarator[-1] = self.__declarator[-1] + <span class="py-string">'[%d]'</span>%i</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_typedef">visit_typedef</a>(self, typedef):</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">      <span class="py-comment">#self.write('@node ' + self.decl_label(typedef.name) + '\n')</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line">      self.write(<span class="py-string">'@deftp '</span> + typedef.type + <span class="py-string">' {'</span> + self.format_type(typedef.alias) + <span class="py-string">'} {'</span> + self.decl_label(typedef.name) + <span class="py-string">'}\n'</span>)</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">      self.format_comments(typedef)</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">      self.write(<span class="py-string">'@end deftp\n'</span>)</span>
<a id="line133"></a><span class="lineno">133</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_variable">visit_variable</a>(self, variable):</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">      <span class="py-comment">#self.write('@node ' + self.decl_label(variable.name) + '\n')</span></span>
<a id="line137"></a><span class="lineno">137</span><span class="line">      self.write(<span class="py-string">'@deftypevr {'</span> + variable.type + <span class="py-string">'} {'</span> + self.format_type(variable.vtype) + <span class="py-string">'} {'</span> + self.decl_label(variable.name) + <span class="py-string">'}\n'</span>)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">      <span class="py-comment">#FIXME !: how can values be represented in texinfo ?</span></span>
<a id="line139"></a><span class="lineno">139</span><span class="line">      self.format_comments(variable)</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">      self.write(<span class="py-string">'@end deftypevr\n'</span>)</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_const">visit_const</a>(self, const):</span>
<a id="line143"></a><span class="lineno">143</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">      <span class="py-keyword">print</span> <span class="py-string">&quot;sorry, &lt;const&gt; not implemented&quot;</span></span>
<a id="line145"></a><span class="lineno">145</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_module">visit_module</a>(self, module):</span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">      <span class="py-comment">#self.write('@node ' + self.decl_label(module.name) + '\n')</span></span>
<a id="line149"></a><span class="lineno">149</span><span class="line">      self.write(<span class="py-string">'@deftp '</span> + module.type + <span class="py-string">' '</span> + self.decl_label(module.name) + <span class="py-string">'\n'</span>)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">      self.format_comments(module)</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">      old_scope = self.scope</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">      self.scope = module.name</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">      <span class="py-comment">#menu = MenuMaker(str(self.scope), self.os)</span></span>
<a id="line154"></a><span class="lineno">154</span><span class="line">      <span class="py-comment">#menu.start()</span></span>
<a id="line155"></a><span class="lineno">155</span><span class="line">      <span class="py-comment">#for declaration in module.declarations: declaration.accept(menu)</span></span>
<a id="line156"></a><span class="lineno">156</span><span class="line">      <span class="py-comment">#menu.end()</span></span>
<a id="line157"></a><span class="lineno">157</span><span class="line">      <span class="py-keyword">for</span> declaration <span class="py-keyword">in</span> module.declarations: declaration.accept(self)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">      self.scope = old_scope</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">      self.write(<span class="py-string">'@end deftp\n'</span>)</span>
<a id="line160"></a><span class="lineno">160</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_class">visit_class</a>(self, class_):</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">      <span class="py-comment">#self.write('@node ' + self.decl_label(clas.name) + '\n')</span></span>
<a id="line164"></a><span class="lineno">164</span><span class="line">      self.write(<span class="py-string">'@deftp '</span> + class_.type + <span class="py-string">' '</span> + self.decl_label(class_.name) + <span class="py-string">'\n'</span>)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">      <span class="py-keyword">if</span> len(class_.parents):</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">         self.write(<span class="py-string">'parents:'</span>)</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">         first = 1</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">         <span class="py-keyword">for</span> parent <span class="py-keyword">in</span> class_.parents:</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> first: self.write(<span class="py-string">', '</span>)</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">            <span class="py-keyword">else</span>: self.write(<span class="py-string">' '</span>)</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">            parent.accept(self)</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">         self.write(<span class="py-string">'\n'</span>)</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">      self.format_comments(class_)</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">      old_scope = self.scope</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">      self.scope = class_.name</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">      <span class="py-comment">#menu = MenuMaker(str(self.scope), self.os)</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line">      <span class="py-comment">#menu.start()</span></span>
<a id="line178"></a><span class="lineno">178</span><span class="line">      <span class="py-comment">#for d in class_.declarations: d.accept(menu)</span></span>
<a id="line179"></a><span class="lineno">179</span><span class="line">      <span class="py-comment">#menu.end()</span></span>
<a id="line180"></a><span class="lineno">180</span><span class="line">      <span class="py-keyword">for</span> d <span class="py-keyword">in</span> class_.declarations:</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">         d.accept(self)</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">      self.scope = old_scope</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">      self.write(<span class="py-string">'@end deftp\n'</span>)</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_inheritance">visit_inheritance</a>(self, inheritance):</span>
<a id="line186"></a><span class="lineno">186</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">      self.write(<span class="py-string">'parent class'</span>)</span>
<a id="line188"></a><span class="lineno">188</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_parameter">visit_parameter</a>(self, parameter):</span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">      parameter.type.accept(self)</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">      label = self.write(<span class="py-string">'{'</span> + self.type_label() + <span class="py-string">'}'</span>)</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">      label = self.write(<span class="py-string">' @var{'</span> + parameter.name + <span class="py-string">'}'</span>)</span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_function">visit_function</a>(self, function):</span>
<a id="line196"></a><span class="lineno">196</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">      ret = function.return_type</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">      <span class="py-keyword">if</span> ret:</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">         ret.accept(self)</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">         ret_label = <span class="py-string">'{'</span> + self.type_label() + <span class="py-string">'}'</span></span>
<a id="line201"></a><span class="lineno">201</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">         ret_label = <span class="py-string">'{}'</span></span>
<a id="line203"></a><span class="lineno">203</span><span class="line">      self.write(<span class="py-string">'@deftypefn '</span> + function.type + <span class="py-string">' '</span> + ret_label + <span class="py-string">' '</span> + self.decl_label(function.real_name) + <span class="py-string">' ('</span>)</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">      first = 1</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">      <span class="py-keyword">for</span> parameter <span class="py-keyword">in</span> function.parameters:</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> first: self.write(<span class="py-string">', '</span>)</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">         <span class="py-keyword">else</span>: self.write(<span class="py-string">' '</span>)</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">         parameter.accept(self)</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">         first = 0</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">      self.write(<span class="py-string">')\n'</span>)</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">      <span class="py-comment">#    map(lambda e, this=self: this.entity(&quot;exceptionname&quot;, e), operation.exceptions)</span></span>
<a id="line212"></a><span class="lineno">212</span><span class="line">      self.format_comments(function)</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">      self.write(<span class="py-string">'@end deftypefn\n'</span>)</span>
<a id="line214"></a><span class="lineno">214</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_operation">visit_operation</a>(self, operation):</span>
<a id="line216"></a><span class="lineno">216</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">      ret = operation.return_type</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">      <span class="py-keyword">if</span> ret:</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">         ret.accept(self)</span>
<a id="line220"></a><span class="lineno">220</span><span class="line">         ret_label = <span class="py-string">'{'</span> + self.type_label() + <span class="py-string">'}'</span></span>
<a id="line221"></a><span class="lineno">221</span><span class="line">      <span class="py-keyword">else</span>:</span>
<a id="line222"></a><span class="lineno">222</span><span class="line">         ret_label = <span class="py-string">'{}'</span></span>
<a id="line223"></a><span class="lineno">223</span><span class="line">      <span class="py-keyword">try</span>:</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">         <span class="py-comment">#self.write('@node ' + self.decl_label(operation.name) + '\n')</span></span>
<a id="line225"></a><span class="lineno">225</span><span class="line">         self.write(<span class="py-string">'@deftypeop '</span> + operation.type + <span class="py-string">' '</span> + self.decl_label(self.scope) + <span class="py-string">' '</span> + ret_label + <span class="py-string">' '</span> + self.decl_label(operation.real_name) + <span class="py-string">' ('</span>)</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">      <span class="py-keyword">except</span>:</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">         <span class="py-keyword">print</span> operation.real_name</span>
<a id="line228"></a><span class="lineno">228</span><span class="line">         sys.exit(0)</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">      first = 1</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">      <span class="py-keyword">for</span> parameter <span class="py-keyword">in</span> operation.parameters:</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">         <span class="py-keyword">if</span> <span class="py-keyword">not</span> first: self.write(<span class="py-string">', '</span>)</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">         <span class="py-keyword">else</span>: self.write(<span class="py-string">' '</span>)</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">         parameter.accept(self)</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">         first = 0</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">      self.write(<span class="py-string">')\n'</span>)</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">      <span class="py-comment">#    map(lambda e, this=self: this.entity(&quot;exceptionname&quot;, e), operation.exceptions)</span></span>
<a id="line237"></a><span class="lineno">237</span><span class="line">      self.format_comments(operation)</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">      self.write(<span class="py-string">'@end deftypeop\n'</span>)</span>
<a id="line239"></a><span class="lineno">239</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_enumerator">visit_enumerator</a>(self, enumerator):</span>
<a id="line241"></a><span class="lineno">241</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">      self.write(<span class="py-string">'@deftypevr {'</span> + enumerator.type + <span class="py-string">'} {} {'</span> + self.decl_label(enumerator.name) + <span class="py-string">'}'</span>)</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">      <span class="py-comment">#FIXME !: how can values be represented in texinfo ?</span></span>
<a id="line244"></a><span class="lineno">244</span><span class="line">      <span class="py-keyword">if</span> enumerator.value: self.write(<span class="py-string">'\n'</span>)</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">      <span class="py-keyword">else</span>: self.write(<span class="py-string">'\n'</span>)</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">      self.format_comments(enumerator)</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">      self.write(<span class="py-string">'@end deftypevr\n'</span>)</span>
<a id="line248"></a><span class="lineno">248</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">   <span class="py-keyword">def</span> <a href="../../../Scopes/Synopsis/Formatters/Texinfo/Formatter.html#visit_enum">visit_enum</a>(self, enum):</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">      <span class="py-comment">#self.write('@node ' + self.decl_label(enum.name) + '\n')</span></span>
<a id="line251"></a><span class="lineno">251</span><span class="line">      self.write(<span class="py-string">'@deftp '</span> + enum.type + <span class="py-string">' '</span> + self.decl_label(enum.name) + <span class="py-string">'\n'</span>)</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">      self.format_comments(enum)</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">      <span class="py-keyword">for</span> enumerator <span class="py-keyword">in</span> enum.enumerators:</span>
<a id="line254"></a><span class="lineno">254</span><span class="line">         enumerator.accept(self)</span>
<a id="line255"></a><span class="lineno">255</span><span class="line">      self.write(<span class="py-string">'@end deftp\n'</span>)</span>
<a id="line256"></a><span class="lineno">256</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
